<template>
  <v-dialog v-model="isOpen" max-width="450px" scrollable>
    <v-card :tile="$vuetify.breakpoint.smAndDown">
      <!-- Title -->
      <v-card-title>
        Insert table

        <v-spacer />

        <!-- Close -->
        <v-btn icon @click="isOpen = false">
          <v-icon>mdi-close</v-icon>
        </v-btn>
      </v-card-title>

      <!-- Content -->
      <v-card-content>
        <!-- Form -->
        <v-form ref="form" lazy-validation>
          <v-row>
            <!-- Columns -->
            <v-col cols="12" md="6">
              <v-text-field
                v-model="fields.columns"
                class="studium-input"
                hide-details="auto"
                label="Columns"
                color="primary"
                outlined
                dense
              />
            </v-col>

            <!-- Rows -->
            <v-col cols="12" md="6">
              <v-text-field
                v-model="fields.rows"
                class="studium-input"
                hide-details="auto"
                label="Rows"
                color="primary"
                outlined
                dense
              />
            </v-col>
          </v-row>

          <v-row>
            <!-- Include header row -->
            <v-col cols="12">
              <v-checkbox
                v-model="fields.withHeaderRow"
                class="mt-0"
                label="Include header row"
                hide-details="auto"
                hint="Should the first row be a header"
                persistent-hint
                color="primary"
                dense
              />
            </v-col>
          </v-row>
        </v-form>
      </v-card-content>

      <!-- Actions -->
      <v-card-actions>
        <v-spacer />

        <!-- Insert -->
        <v-btn class="studium-button" color="primary" text :ripple="false" @click="onInsert"> Insert </v-btn>

        <!-- Cancel -->
        <v-btn class="studium-button" color="secondary" text large :ripple="false" @click="onCancel"> Cancel </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script lang="ts">
import { defineComponent, reactive } from '@nuxtjs/composition-api'
import { useVModel } from '@vueuse/core'

export default defineComponent({
  props: {
    // Synchronised property if the dialog is open
    open: {
      type: Boolean,
      default: false,
    },
  },
  setup(props, { emit }) {
    const isOpen = useVModel(props, 'open', emit)

    // Form fields
    const fields = reactive({
      columns: 3,
      rows: 2,
      withHeaderRow: true,
    })

    // Insert button press event handler
    function onInsert() {
      emit('insert', fields)
      isOpen.value = false
    }

    // Cancel button press event handler
    function onCancel() {
      isOpen.value = false
    }

    return {
      isOpen,
      fields,
      onInsert,
      onCancel,
    }
  },
})
</script>
